﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Media;
using Microsoft.Xna.Framework.Graphics.PackedVector;



namespace WindowsGame
{
	public class EnemiesResources
	{
		public Model model;

		public EnemiesResources(ContentManager content)
		{
			model = content.Load<Model>("Models\\EnemyTank");

			foreach(ModelMesh mesh in model.Meshes)
				foreach(BasicEffect effect in mesh.Effects)
				{
					effect.EnableDefaultLighting();
					effect.AmbientLightColor = new Vector3(0.6f, 0.6f, 0.6f);
					effect.DirectionalLight0.SpecularColor = new Vector3(1.0f, 1.0f, 1.0f);
					effect.DirectionalLight0.DiffuseColor = new Vector3(1.0f, 1.0f, 1.0f);
					effect.DirectionalLight1.Enabled = false;
					effect.DirectionalLight2.Enabled = false;
				}
		}
	}
}